# -*- coding: utf-8 -*-

from Plugins.Plugin import PluginDescriptor
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Screens.ChoiceBox import ChoiceBox
from Screens.LocationBox import MovieLocationBox
from Screens.InputBox import InputBox
from Screens.Console import Console
from Components.config import *
from Components.ActionMap import ActionMap, NumberActionMap
from Components.ConfigList import ConfigList, ConfigListScreen
from Components.Button import Button
from Components.Label import Label
from Components.Pixmap import Pixmap
from Components.UsageConfig import defaultMoviePath
from enigma import eServiceReference, eServiceCenter, iServiceInformation
from Tools.Directories import *
import os

global VIDEODIR_LIST
VIDEODIR_LIST = [("Aufnahme-Ordner (Standard)", defaultMoviePath(), defaultMoviePath())]

def main(session, service, **kwargs):
	MovieMove(session, service, **kwargs)

def Plugins(**kwargs):
	return PluginDescriptor(name="Videothek", description=_("verschieben/kopieren ..."), where = PluginDescriptor.WHERE_MOVIELIST, fnc=main)


class MovieMove(Screen):
		def __init__(self, session, service, args = 0):
			self.session = session
			self.service = service
			Screen.__init__(self, session)
			serviceHandler = eServiceCenter.getInstance()
			info = serviceHandler.info(self.service)
			self.path = self.service.getPath()
			self.name = info.getName(self.service)
			self.descr = info.getInfoString(self.service, iServiceInformation.sDescription)
			self.filename=""
			self.moviename=""
			self.destinationpath=""
			self.sourcepath=""
			

			VIDEODIR_LIST = [("Aufnahme-Ordner (Standard)", defaultMoviePath(), defaultMoviePath())]
			use_config = True
			use_moviepath = False
			listpath = []
			listpath_cf = []
			configFile = resolveFilename(SCOPE_CONFIG)+"videothek.cfg" # look for the config file
			if fileExists(configFile):
				cf = open(configFile,"r") # read the config file
				for line in cf:
					if line.lower().replace(" ","") == "use_config=no\n":
						use_config = False
						break
					else:
						if line.lower().replace(" ","") == "use_moviepath=yes\n":
							use_moviepath = True
						if line.startswith("entry"):
							parts = line.rsplit("=")[1].split(";")
							if pathExists(parts[1].strip()):
								listpath_entry = []
								listpath_entry.append((parts[0].strip(), (parts[0].strip(),SCOPE_USERETC,parts[1].strip())))
								if parts[len(parts)-1].find("no_subdirs")== -1:
									subdir_depth=99
									if not parts[len(parts)-1].find("subdirs") == -1:
										subdir_depth=int(parts[len(parts)-1].split("_")[0].strip())
									for base, dirs, files in os.walk(parts[1].strip()): #find subdirs
										subdir = base.rsplit(parts[1].strip(),1)[1]
										if subdir.find(".",0,1)==-1: #exept hidden directories
											if subdir <> "":
												if len(subdir.split("/")) < subdir_depth+1:
													listpath_entry.append((parts[0].strip()+"/"+subdir,(parts[0].strip()+"/"+subdir,SCOPE_USERETC,resolveFilename(SCOPE_USERETC,parts[1].strip()+subdir)+"/")))
								listpath_entry.sort()
								listpath_cf.extend(listpath_entry) #add sorted entry and enty-subdir-values to listpath_cf
				cf.close()
			else:
				use_config = False		
			
			for base, dirs, files in os.walk(defaultMoviePath()): 
				subdir = base.rsplit(defaultMoviePath(),1)[1]
				if subdir.find(".",0,1)==-1: #exept hidden directories
					if subdir <> "":
						listpath.append((subdir,(subdir,SCOPE_USERETC,defaultMoviePath()+subdir+"/")))
			listpath.sort() #sorts only moviepath-values from /hdd/movie
	
			if use_config:
				if use_moviepath:
					listpath.extend(listpath_cf) #add config values to moviepath values
					listpath.insert(0, (VIDEODIR_LIST[0][0], VIDEODIR_LIST[0])) # the first entry is fixed!
				else:
					listpath = listpath_cf
			else:
				listpath.insert(0, (VIDEODIR_LIST[0][0], VIDEODIR_LIST[0])) # the first entry is fixed!
			
			self.listpath_pathes=listpath
			#listpath_pathes.extend(listpath)
			
			cbkeys =[]
			for element in range(len(listpath)):
				if element<=10:
					cbkeys.append(str(element))
				else:
					cbkeys.append("")
	
			listpath.append(("Verzeichnisauswahl aufrufen ...",("Verzeichnisauswahl aufrufen ...","","")))
			cbkeys.append("blue")
			listpath.append(("Erstelle neues Verzeichnis ...",("Verzeichnis erstellen ...","","")))
			cbkeys.append("green")
			listpath.append(("Auflistung aktiver Verschiebe-/Kopierprozesse",("Auflistung aktiver Verschiebe-/Kopierprozesse","","")))
			cbkeys.append("yellow")
						
			if len(os.listdir(config.movielist.last_videodir.value)) == 0 and defaultMoviePath()<>config.movielist.last_videodir.value:
				listpath.append(("Entferne '%s'" % config.movielist.last_videodir.value,("Verzeichnis entfernen ...","","")))
				cbkeys.append("red")
			self.session.openWithCallback(self.SelectPathConfirmed, ChoiceBox, title=_("Wählen Sie das Verzeichnis, in welches die Aufnahme '%s' verschoben/kopiert werden soll." % (self.name)), list = listpath,keys = cbkeys)

		def SelectPathConfirmed(self, answer):
			if answer is not  None:
				if answer[0]=="Verzeichnisauswahl aufrufen ...":
					self.session.openWithCallback(self.gotFilename,MovieLocationBox,_("Please select the movie path..."),config.movielist.last_videodir.value)
				elif answer[0]=="Erstelle neues Verzeichnis ...":
					self.session.openWithCallback(self.SelectedParentDir,ChoiceBox, title=_("In welchem Verzeichnis soll dass Unterverzeichnis erstellt werden?"), list = self.listpath_pathes)
					#self.session.openWithCallback(self.CreateConfirmedPath,InputBox,_("Erstelle in '%s'..." % config.movielist.last_videodir.value), text=" Neues Verzeichnis")
				elif answer[0]=="Auflistung aktiver Verschiebe-/Kopierprozesse":
					tmp_out = os.popen("ps -ef | grep -e \"   [c]p /\" -e \"   [m]v /\"").readlines()
					tmpline = ""
					tmpcount = 0
					for line in tmp_out:
						tmpcount = tmpcount + 1
						tmpline = tmpline+"\n"+line.replace(" cp ","|Kopiere:\n",1).replace(" mv ","|Verschiebe:\n",1).split("|",1)[1].rsplit(".",1)[0]
					if tmpcount == 0:
						self.session.open(MessageBox,_("Es werden derzeit keine Dateien kopiert/verschoben."), MessageBox.TYPE_INFO, 5)
					elif tmpcount == 1:
						self.session.open(MessageBox,_("Folgende Datei wird derzeit kopiert/verschoben:\n %s" % tmpline), MessageBox.TYPE_INFO)
					else:
						self.session.open(MessageBox,_("Folgende %s Dateien werden derzeit kopiert/verschoben:\n %s" % (str(tmpcount), tmpline)), MessageBox.TYPE_INFO)					
				elif answer[0]=="Entferne '%s'" % config.movielist.last_videodir.value:
					os.rmdir(config.movielist.last_videodir.value)
					self.gotFilename(defaultMoviePath())
				else:
					self.gotFilename(answer[1][2])

		def SelectedParentDir(self,SelectedParent):
			if SelectedParent is not None and SelectedParent <> "":
				self.ParentDir = SelectedParent[1][2]
				self.session.openWithCallback(self.CreateConfirmedPath,InputBox,_("Erstelle in '%s'..." % self.ParentDir), text=" Neues Verzeichnis")
						
		def CreateConfirmedPath(self,DirToCreate):
			if DirToCreate is not None and DirToCreate <> "":
				#if createDir(config.movielist.last_videodir.value+DirToCreate.strip()):
				if createDir(self.ParentDir+DirToCreate.strip()):
					#self.gotFilename(config.movielist.last_videodir.value+DirToCreate.strip())
					main(self.session,self.service)
				else:
					self.session.openWithCallback(main(self.session,self.service), MessageBox,_("Das Verzeichnis '%s' konnte nicht angelegt werden." % (config.movielist.last_videodir.value +DirToCreate.lstrip())), MessageBox.TYPE_WARNING)
			else:
				main(self.session,self.service)	
			
		def gotFilename(self, destinationpath):
			if destinationpath is None:
				self.skipMoveFile("Verzeichnisauswahl wurde abgebrochen")
			else:
				self.filename = self.path.rsplit('/',1)[1]
				self.moviename = self.filename.rsplit(".",1)[0]
				self.destinationpath = destinationpath
				self.sourcepath=self.path.rsplit('/',1)[0]
				listtmp = [("Verschieben (sofort)","VS"),("Verschieben (im Hintergrund)","VH"),("Kopieren (sofort)","KS"),("Kopieren (im Hintergrund)","KH"),("Abbruch","Abbruch") ]
				self.session.openWithCallback(self.DoMove, ChoiceBox, title=_("'%s'\n\nvon   '%s'\nnach '%s' verschieben oder kopieren?" % (self.name,self.sourcepath,self.destinationpath) ), list = listtmp)
		
		def DoMove(self,confirmed):
			if confirmed is not None:
				if confirmed[1] <> "Abbruch":
					if os.path.exists(self.destinationpath) is False:
						os.system("mkdir %s" % self.destinationpath)
					if os.path.exists(self.destinationpath + "/%s" % self.filename) is True:
						self.skipMoveFile("Datei existiert bereits")
					elif confirmed[1] == "VS":
						os.system("mv \"%s/%s.\"* \"%s\"" % (self.sourcepath,self.moviename,self.destinationpath))
						self.session.openWithCallback(self.DoneForeground, MessageBox,_("Das Verschieben der Aufnahme wurde durchgeführt."), MessageBox.TYPE_INFO,timeout = 3)
					elif confirmed[1] == "VH":
						os.system("mv \"%s/%s.\"* \"%s\" &" % (self.sourcepath,self.moviename,self.destinationpath))
						self.session.openWithCallback(self.DoneBackground, MessageBox,_("Das Verschieben der Aufnahme erfolgt im Hintergrund.\n\nDie Aufnahmeliste kann erst nach vollständigem Abschluss aktualisiert angezeigt werden."), MessageBox.TYPE_INFO,timeout = 12)
					elif confirmed[1] == "KS":
						os.system("cp \"%s/%s.\"* \"%s\"" % (self.sourcepath,self.moviename,self.destinationpath))
						self.session.openWithCallback(self.DoneForeground, MessageBox,_("Das Kopieren der Aufnahme wurde durchgeführt."), MessageBox.TYPE_INFO,timeout = 3)
					elif confirmed[1] == "KH":
						os.system("cp \"%s/%s.\"* \"%s\" &" % (self.sourcepath,self.moviename,self.destinationpath))
						self.session.openWithCallback(self.DoneBackground, MessageBox,_("Das Kopieren der Aufnahme erfolgt im Hintergrund.\n\nDie Aufnahmeliste kann erst nach vollständigem Abschluss aktualisiert angezeigt werden."), MessageBox.TYPE_INFO,timeout = 12)
				else:
					main(self.session,self.service)

		def DoneForeground(self,confirmed):
			self.session.current_dialog.close()
			self.session.current_dialog.csel.reloadList()
		
		def DoneBackground(self,confirmed):
			self.session.current_dialog.close()
			
		def skipMoveFile(self,reason):
			self.session.open(MessageBox,_("Die Aufnahme konnte nicht verschoben/kopiert werden, %s." % reason), MessageBox.TYPE_WARNING)